package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import lombok.Data;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.demo.domain.UserGroup;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import java.util.Map;
import java.util.Date;
import org.springframework.cglib.beans.BeanCopier;
import javax.validation.constraints.Size;
import java.util.UUID;
import org.springframework.cglib.beans.BeanCopier;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserGroup_EditForm_Main2{

    @JsonProperty(access=Access.WRITE_ONLY)
    private Map<String,String> srfparentdata;
    @JsonIgnore
    private Timestamp updatedate;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srforikey;
    @JsonIgnore
    private String usergroupid;
    @JsonIgnore
    private String usergroupname;
    @JsonIgnore
    private String srftempmode;
    @JsonProperty
    private String srfuf;
    @JsonProperty
    private String srfdeid;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srfsourcekey;
    @JsonIgnore
    private String userdata;
    @JsonIgnore
    private String userdata2;
    @JsonIgnore
    private String memo;

    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JsonProperty(value = "srfupdatedate")
    public Timestamp getSrfupdatedate(){
        return updatedate;
    }
    @JsonProperty(value = "srfupdatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    public void setSrfupdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
    }

    @JsonProperty(value = "srforikey")
    public String getSrforikey(){
        return srforikey;
    }
    @JsonProperty(value = "srforikey")
    public void setSrforikey(String srforikey){
        this.srforikey = srforikey;
    }

    @Size(min = 0, max = 100, message = "[用户组标识]长度必须在[100]以内!")
    @JsonProperty(value = "srfkey")
    public String getSrfkey(){
        return usergroupid;
    }
    @JsonProperty(value = "srfkey")
    public void setSrfkey(String usergroupid){
        this.usergroupid = usergroupid;
    }

    @Size(min = 0, max = 200, message = "[用户组名称]长度必须在[200]以内!")
    @JsonProperty(value = "srfmajortext")
    public String getSrfmajortext(){
        return usergroupname;
    }

    @JsonProperty(value = "srftempmode")
    public String getSrftempmode(){
        return srftempmode;
    }
    @JsonProperty(value = "srftempmode")
    public void setSrftempmode(String srftempmode){
        this.srftempmode = srftempmode;
    }

    @JsonProperty(value = "srfdeid")
    public String getSrfdeid(){
        return srfdeid;
    }
    @JsonProperty(value = "srfdeid")
    public void setSrfdeid(String srfdeid){
        this.srfdeid = srfdeid;
    }

    @Size(min = 0, max = 100, message = "[用户组标识]长度必须在[100]以内!")
    @JsonProperty(value = "usergroupid")
    public String getUsergroupid(){
        return usergroupid;
    }
    @JsonProperty(value = "usergroupid")
    public void setUsergroupid(String usergroupid){
        this.usergroupid = usergroupid;
    }

    @NotBlank(message = "[用户组名称]不允许为空!")
    @Size(min = 0, max = 200, message = "[用户组名称]长度必须在[200]以内!")
    @JsonProperty(value = "usergroupname")
    public String getUsergroupname(){
        return usergroupname;
    }
    @JsonProperty(value = "usergroupname")
    public void setUsergroupname(String usergroupname){
        this.usergroupname = usergroupname;
    }

    @Size(min = 0, max = 100, message = "[自定义数据]长度必须在[100]以内!")
    @JsonProperty(value = "userdata")
    public String getUserdata(){
        return userdata;
    }
    @JsonProperty(value = "userdata")
    public void setUserdata(String userdata){
        this.userdata = userdata;
    }

    @Size(min = 0, max = 100, message = "[自定义数据2]长度必须在[100]以内!")
    @JsonProperty(value = "userdata2")
    public String getUserdata2(){
        return userdata2;
    }
    @JsonProperty(value = "userdata2")
    public void setUserdata2(String userdata2){
        this.userdata2 = userdata2;
    }

    @Size(min = 0, max = 2000, message = "[备注]长度必须在[2000]以内!")
    @JsonProperty(value = "memo")
    public String getMemo(){
        return memo;
    }
    @JsonProperty(value = "memo")
    public void setMemo(String memo){
        this.memo = memo;
    }

    public  void fromUserGroup(UserGroup sourceEntity)  {
        this.fromUserGroup(sourceEntity,true);
    }

     /**
	 * do转换为vo
	 * @param sourceEntity do数据对象
	 * @return
	 */
    public  void fromUserGroup(UserGroup sourceEntity,boolean reset)  {
      BeanCopier copier=BeanCopier.create(UserGroup.class, UserGroup_EditForm_Main2.class, false);
      copier.copy(sourceEntity,this,  null);
      this.toString();
	}

    /**
	 * vo转换为do
	 * @param
	 * @return
	 */
    public  UserGroup toUserGroup()  {
        UserGroup targetEntity =new UserGroup();
        BeanCopier copier=BeanCopier.create(UserGroup_EditForm_Main2.class, UserGroup.class, false);
        copier.copy(this, targetEntity, null);
        return targetEntity;
	}

     /**
	 * 新建
	 * @param
	 * @return
	 */
    private boolean isCreate()
    {
    	if((StringUtils.isEmpty(this.srfuf))||this.srfuf.equals("0"))
	    	return true;
    	else
    	    return false;
    }
     /**
	 * 更新
	 * @param
	 * @return
	 */
    private boolean isUpdate()
    {
    	if((!StringUtils.isEmpty(this.srfuf))&&this.srfuf.equals("1"))
	    	return true;
    	else
    	    return false;
    }

}
